=== modified file 'NEWS'
--- NEWS	2008-03-06 01:59:26 +0000
+++ NEWS	2008-03-03 23:11:53 +0000
@@ -1,12 +1,6 @@
 What's changed in loggerhead?
 =============================
 
-1.2.1  [06mar2008]
-------------------
-
-    - The changelog view was out of order when not using the revision
-      cache.
-
 1.2  [04mar2008]
 ----------------
 

=== modified file 'loggerhead.conf.example'
--- loggerhead.conf.example	2008-03-06 07:30:37 +0000
+++ loggerhead.conf.example	2007-06-18 23:07:53 +0000
@@ -5,9 +5,6 @@
 # use this if you're mapping loggerhead within apache via proxy
 #server.webpath = 'http://example.com/branches'
 
-# use this if you want loggerhead to listen to another interface than 127.0.0.1
-# server.socket_host = 'your_hostname_or_ip'
-
 # where's bzrlib?
 # (you only need this if you don't install bzr.)
 #bzrpath = '/Users/robey/code/bzr/bzr'

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2008-03-06 02:35:59 +0000
+++ loggerhead/history.py	2008-02-27 03:36:09 +0000
@@ -656,12 +656,8 @@
         revid_list = filter(lambda revid: not bzrlib.revision.is_null(revid),
                             revid_list)
         repo = self._branch.repository
-        parent_map = repo.get_graph().get_parent_map(revid_list)
-        # We need to return the answer in the same order as the input,
-        # less any ghosts.
-        present_revids = [revid for revid in revid_list
-                          if revid in parent_map]
-        rev_list = repo.get_revisions(present_revids)
+        rev_list = repo.get_revisions(
+            repo.get_graph().get_parent_map(revid_list))
 
         return [self._change_from_revision(rev) for rev in rev_list]
 

=== modified file 'loggerhead/release.py'
--- loggerhead/release.py	2008-03-06 01:59:26 +0000
+++ loggerhead/release.py	2008-02-28 04:45:06 +0000
@@ -1,6 +1,6 @@
 # Release information about loggerhead
 
-version = "1.2.1"
+version = "1.2"
 
 description = "Loggerhead is a web viewer for projects in bazaar."
 

=== modified file 'loggerhead/templates/annotate.kid'
--- loggerhead/templates/annotate.kid	2008-03-09 00:22:47 +0000
+++ loggerhead/templates/annotate.kid	2007-09-04 17:06:03 +0000
@@ -31,7 +31,7 @@
             <td class="lineno ${line.status}"><a name="L${line.lineno}"> ${line.lineno} </a></td>
             <td class="revno ${line.status}">
                 <a py:if="line.status=='changed'" href="${branch.url('/revision', **util.get_context(clear=1, start_revid=line.change.revid, file_id=file_id))}"
-                    title="${line.change.revno} by ${util.hide_email(line.change.author)}, ${util.date_time(line.change.date)}">${util.trunc(line.change.revno)}</a>
+                    title="${line.change.revno} by ${util.hide_email(line.change.author)}, on ${util.format_date(line.change.date)} (${util.ago(line.change.date)})">${util.trunc(line.change.revno)}</a>
             </td>
             <td class="text ${line.status}"> ${line.text} </td>
         </tr>

=== modified file 'loggerhead/templates/browse.kid'
--- loggerhead/templates/browse.kid	2008-03-09 00:22:47 +0000
+++ loggerhead/templates/browse.kid	2008-02-27 01:55:39 +0000
@@ -34,7 +34,7 @@
             <tr>
             <td class="name"> <a href="${tg.url([ '/' + project.name, view.name ])}">${view.friendly_name}</a> </td>
             <td class="description"> ${view.description} </td>
-            <td class="last-update"> ${view.get_history().has_revisions and util.approximatedate(view.last_updated()) or "(no revisions)"} </td>
+            <td class="last-update"> ${view.get_history().has_revisions and util.ago(view.last_updated()) or "(no revisions)"} </td>
             <td class="feed">
                 <a href="${tg.url([ '/' + project.name, view.name, 'atom' ])}" title="atom feed">
                     <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" alt="atom feed" />

=== modified file 'loggerhead/templates/changelog.kid'
--- loggerhead/templates/changelog.kid	2008-03-09 00:22:47 +0000
+++ loggerhead/templates/changelog.kid	2007-09-04 17:21:59 +0000
@@ -77,7 +77,7 @@
             <span py:strip="True" py:if="not all_same_author">
                 <td class="author"> ${util.trunc(util.hide_email(entry.author), 20)} </td>
             </span>
-            <td class="date"> ${util.approximatedate(entry.date)} </td>
+            <td class="date"> ${util.format_date(entry.date)} &nbsp; (${util.ago(entry.date)}) </td>
             <td class="inventory-link"> 
                 <a href="${branch.url([ '/files', entry.revid ])}"
                     title="Files at revision ${entry.revno}"> files</a>

=== modified file 'loggerhead/templates/inventory.kid'
--- loggerhead/templates/inventory.kid	2008-03-09 00:22:47 +0000
+++ loggerhead/templates/inventory.kid	2007-09-04 17:06:03 +0000
@@ -28,7 +28,7 @@
         </tr>
         <tr>
             <th class="date">date:</th>
-            <td class="date"> ${util.date_time(change.date)} </td>
+            <td class="date"> ${util.format_date(change.date)} </td>
         </tr>
 
         <tr py:if="len(change.merge_points) > 0">
@@ -86,7 +86,7 @@
                 file_id=file.file_id)}" title="Annotate ${file.filename}">${file.filename}</a>
         </td>
         <td class="revision"> ${revision_link(file.revid, util.trunc(file.change.revno, 15), **util.get_context(start_revid=file.revid, file_id=file.file_id))} </td>
-        <td class="date"> ${util.date_time(file.change.date)} </td>
+        <td class="date"> ${util.format_date(file.change.date)} </td>
         <td class="size"> <span py:if="file.kind=='file'"> ${util.human_size(file.size)} </span></td>
         <td class="changes-link"> 
             <a href="${branch.context_url('/changes', start_revid=file.revid, file_id=file.file_id)}"

=== modified file 'loggerhead/templates/master.kid'
--- loggerhead/templates/master.kid	2008-03-07 10:16:51 +0000
+++ loggerhead/templates/master.kid	2007-09-02 22:54:43 +0000
@@ -1,106 +1,106 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<?python import sitetemplate ?>
-<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#" py:extends="sitetemplate">
-
-<head py:match="item.tag=='{http://www.w3.org/1999/xhtml}head'" py:attrs="item.items()">
-    <meta content="text/html; charset=UTF-8" http-equiv="content-type" py:replace="''"/>
-    <title py:replace="''">Your title goes here</title>
-    <meta py:replace="item[:]"/>
-    <style type="text/css" media="screen">
-@import "${tg.url('/static/css/style.css')}";
-    </style>
-
-<!-- !define common navbar -->
-<span py:def="navbar()" py:strip="True">
-    <!-- !requires: ${navigation: start_revid, revid, revid_list, pagesize, buttons, scan_url}, ${branch}, ${history} -->
-    <div class="bar" py:if="navigation is not None">
-        <!-- form must go OUTSIDE the table, or safari will add extra padding :( -->
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<?python import sitetemplate ?>
+<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#" py:extends="sitetemplate">
+
+<head py:match="item.tag=='{http://www.w3.org/1999/xhtml}head'" py:attrs="item.items()">
+    <meta content="text/html; charset=UTF-8" http-equiv="content-type" py:replace="''"/>
+    <title py:replace="''">Your title goes here</title>
+    <meta py:replace="item[:]"/>
+    <style type="text/css" media="screen">
+@import "${tg.url('/static/css/style.css')}";
+    </style>
+
+<!-- !define common navbar -->
+<span py:def="navbar()" py:strip="True">
+    <!-- !requires: ${navigation: start_revid, revid, revid_list, pagesize, buttons, scan_url}, ${branch}, ${history} -->
+    <div class="bar" py:if="navigation is not None">
+        <!-- form must go OUTSIDE the table, or safari will add extra padding :( -->
         <form action="${branch.url('/changes', start_revid=getattr(navigation, 'start_revid', None),
-              file_id=getattr(navigation, 'file_id', None))}"><table><tr>
-            <td><span class="buttons">
-                <!-- ! navbar buttons never change, from now on.  i decree it! -->
-                <a href="${branch.context_url('/changes', clear=1)}"> changes </a>
-                <a href="${branch.context_url('/files', clear=1)}"> files </a>
-                <span class="search"> search: <input type="text" name="q" /> </span>
+              file_id=getattr(navigation, 'file_id', None))}"><table><tr>
+            <td><span class="buttons">
+                <!-- ! navbar buttons never change, from now on.  i decree it! -->
+                <a href="${branch.context_url('/changes', clear=1)}"> changes </a>
+                <a href="${branch.context_url('/files', clear=1)}"> files </a>
+                <span class="search"> search: <input type="text" name="q" /> </span>
             </span></td>
-            <td align="right" py:if="hasattr(navigation, 'revid_list')">
-                <span py:if="hasattr(navigation, 'feed')" class="rbuttons feed">
+            <td align="right" py:if="hasattr(navigation, 'revid_list')">
+                <span py:if="hasattr(navigation, 'feed')" class="rbuttons feed">
                     <a href="${branch.url('/atom')}">
-                    <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" /></a>
-                </span>
-                <span class="navbuttons">
+                    <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" /></a>
+                </span>
+                <span class="navbuttons">
                 	<span py:if="navigation.prev_page_revid">
                 	<a href="${navigation.prev_page_url}" title="Previous page"> &#171; </a>
-                    </span>
-                	<span py:if="not navigation.prev_page_revid"> &#171; </span>
+                    </span>
+                	<span py:if="not navigation.prev_page_revid"> &#171; </span>
                     revision ${history.get_revno(revid)}
-                    (<span py:if="navigation.pagesize > 1">page </span>${navigation.page_position} / ${navigation.page_count})
+                    (<span py:if="navigation.pagesize > 1">page </span>${navigation.page_position} / ${navigation.page_count})
                 	<span py:if="navigation.next_page_revid">
                     <a href="${navigation.next_page_url}" title="Next page"> &#187; </a>
-                    </span>
-                	<span py:if="not navigation.next_page_revid"> &#187; </span>
-                </span>
+                    </span>
+                	<span py:if="not navigation.next_page_revid"> &#187; </span>
+                </span>
             </td>
-        </tr></table></form>
-    </div>
-</span>
-
+        </tr></table></form>
+    </div>
+</span>
+
 <span py:def="revision_link(revid, text, **overrides)" py:strip="True">
     <a title="Show revision ${history.get_revno(revid)}"
        href="${branch.url([ '/revision', revid ], **util.get_context(**overrides))}"> ${text} </a>
 </span>
 
-
-<!-- ! expand button functions: -->
-
-	<span py:strip="True" py:def="use_collapse_buttons()">
-		<!-- this is totally matty's fault.  i don't like javacsript. ;) -->
-		<script type="text/javascript" src="${tg.url('/static/javascript/collapse.js')}"></script>
-	</span>
-	
-	<span py:strip="True" py:def="collapse_all_button(group, normal='block')">
+
+<!-- ! expand button functions: -->
+
+	<span py:strip="True" py:def="use_collapse_buttons()">
+		<!-- this is totally matty's fault.  i don't like javacsript. ;) -->
+		<script type="text/javascript" src="${tg.url('/static/javascript/collapse.js')}"></script>
+	</span>
+	
+	<span py:strip="True" py:def="collapse_all_button(group, normal='block')">
 	    <a class="hide-all collapse-${group}-hideall"
-	       href="javascript:collapseAllDisplay('${group}','none')">
+	       href="javascript:collapseAllDisplay('${group}','none')">
 	        <img src="${tg.url('/static/images/nav-small-down.gif')}"
 	             width="10" height="10" alt="collapse"
-	             class="collapse-triangle" />collapse all</a>
+	             class="collapse-triangle" />collapse all</a>
 	    <a class="hide-all collapse-${group}-showall"
-	       href="javascript:collapseAllDisplay('${group}','${normal}')">
+	       href="javascript:collapseAllDisplay('${group}','${normal}')">
 	        <img src="${tg.url('/static/images/nav-small-right.gif')}"
 	             width="10" height="10" alt="expand"
-	             class="collapse-triangle" />expand all</a>
-	</span>
-	
-	<span py:strip="True" py:def="collapse_button(group, name, normal='block')">
+	             class="collapse-triangle" />expand all</a>
+	</span>
+	
+	<span py:strip="True" py:def="collapse_button(group, name, normal='block')">
 	    <a href="javascript:collapseDisplay('${group}','${name}','none')"
-	       class="hide-button collapse-${group}-${name}-hide" title="collapse">
+	       class="hide-button collapse-${group}-${name}-hide" title="collapse">
 	        <img src="${tg.url('/static/images/nav-small-down.gif')}"
 	             width="10" height="10" alt="collapse"
-	             class="collapse-triangle" />
-	    </a>
+	             class="collapse-triangle" />
+	    </a>
 	    <a href="javascript:collapseDisplay('${group}','${name}','${normal}')"
-	       class="show-button collapse-${group}-${name}-show" title="expand">
+	       class="show-button collapse-${group}-${name}-show" title="expand">
 	    	<img src="${tg.url('/static/images/nav-small-right.gif')}"
 	    	     witdh="10" height="10" alt="expand"
-	    	     class="collapse-triangle" />
-	    </a>
-	</span>
-
-</head>
-
+	    	     class="collapse-triangle" />
+	    </a>
+	</span>
+
+</head>
+
 <body py:match="item.tag=='{http://www.w3.org/1999/xhtml}body'"
-      py:attrs="item.items()">
-
-    <div py:replace="[item.text]+item[:]"/>
-
-	<!-- End of main_content -->
-	
-	<div class="footer">
+      py:attrs="item.items()">
+
+    <div py:replace="[item.text]+item[:]"/>
+
+	<!-- End of main_content -->
+	
+	<div class="footer">
 	    <span class="banner"><a href="http://www.bazaar-vcs.org/">
-	    <img src="${tg.url('/static/images/bazaar-banner.png')}" /></a></span>
+	    <img src="${tg.url('/static/images/bazaar-banner.png')}" /></a></span>
 	    <span class="banner"><a href="http://www.lag.net/loggerhead/">
-	    <img src="${tg.url('/static/images/loggerhead-banner.png')}" /></a></span>
-	</div>
-</body>
-
-</html>
+	    <img src="${tg.url('/static/images/loggerhead-banner.png')}" /></a></span>
+	</div>
+</body>
+
+</html>

=== modified file 'loggerhead/templates/revision.kid'
--- loggerhead/templates/revision.kid	2008-03-09 00:22:47 +0000
+++ loggerhead/templates/revision.kid	2007-09-04 17:06:03 +0000
@@ -84,7 +84,7 @@
         </tr>
         <tr>
             <th class="date">date:</th>
-            <td class="date"> ${util.date_time(change.date)} </td>
+            <td class="date"> ${util.format_date(change.date)} </td>
         </tr>
 
         <tr py:if="len(change.merge_points) > 0">

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2008-03-09 00:22:47 +0000
+++ loggerhead/util.py	2008-02-27 03:36:09 +0000
@@ -17,8 +17,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-from elementtree import ElementTree as ET
-
 import base64
 import cgi
 import datetime
@@ -34,80 +32,67 @@
 
 log = logging.getLogger("loggerhead.controllers")
 
-# Display of times.
-
-# date_day -- just the day
-# date_time -- full date with time
-#
-# displaydate -- for use in sentences
-# approximatedate -- for use in tables
-#
-# displaydate and approximatedate return an elementtree <span> Element
-# with the full date in a tooltip.
-
-def date_day(value):
-    return value.strftime('%Y-%m-%d')
-
-
-def date_time(value):
-    return value.strftime('%Y-%m-%d %T')
-
-
-def _displaydate(date):
-    delta = abs(datetime.datetime.now() - date)
-    if delta > datetime.timedelta(1, 0, 0):
-        # far in the past or future, display the date
-        return 'on ' + date_day(date)
-    return _approximatedate(date)
-
-
-def _approximatedate(date):
+
+def timespan(delta):
+    if delta.days > 730:
+        # good grief!
+        return '%d years' % (int(delta.days // 365.25),)
+    if delta.days >= 3:
+        return '%d days' % delta.days
+    seg = []
+    if delta.days > 0:
+        if delta.days == 1:
+            seg.append('1 day')
+        else:
+            seg.append('%d days' % delta.days)
+    hrs = delta.seconds // 3600
+    mins = (delta.seconds % 3600) // 60
+    if hrs > 0:
+        if hrs == 1:
+            seg.append('1 hour')
+        else:
+            seg.append('%d hours' % hrs)
+    if delta.days == 0:
+        if mins > 0:
+            if mins == 1:
+                seg.append('1 minute')
+            else:
+                seg.append('%d minutes' % mins)
+        elif hrs == 0:
+            seg.append('less than a minute')
+    return ', '.join(seg)
+
+
+def ago(timestamp):
+    now = datetime.datetime.now()
+    return timespan(now - timestamp) + ' ago'
+
+
+def fix_year(year):
+    if year < 70:
+        year += 2000
+    if year < 100:
+        year += 1900
+    return year
+
+
+_g_format = '%Y-%m-%d @ %H:%M'
+
+def format_date(date):
+    if _g_format == 'fancy':
+        return fancy_format_date(date)
+    return date.strftime(_g_format)
+
+def fancy_format_date(date):
     delta = datetime.datetime.now() - date
-    if abs(delta) > datetime.timedelta(1, 0, 0):
-        # far in the past or future, display the date
-        return date_day(date)
-    future = delta < datetime.timedelta(0, 0, 0)
-    delta = abs(delta)
-    days = delta.days
-    hours = delta.seconds / 3600
-    minutes = (delta.seconds - (3600*hours)) / 60
-    seconds = delta.seconds % 60
-    result = ''
-    if future:
-        result += 'in '
-    if days != 0:
-        amount = days
-        unit = 'day'
-    elif hours != 0:
-        amount = hours
-        unit = 'hour'
-    elif minutes != 0:
-        amount = minutes
-        unit = 'minute'
+    if delta.days > 300:
+        return date.strftime('%d %b %Y')
     else:
-        amount = seconds
-        unit = 'second'
-    if amount != 1:
-        unit += 's'
-    result += '%s %s' % (amount, unit)
-    if not future:
-        result += ' ago'
-        return result
-
-
-def _wrap_with_date_time_title(date, formatted_date):
-    elem = ET.Element("span")
-    elem.text = formatted_date
-    elem.set("title", date_time(date))
-    return elem
-
-
-def approximatedate(date):
-    return _wrap_with_date_time_title(date, _approximatedate(date))
-
-
-def displaydate(date):
-    return _wrap_with_date_time_title(date, _displaydate(date))
+        return date.strftime('%d %b %H:%M')
+
+def set_date_format(format):
+    global _g_format
+    _g_format = format
 
 
 class Container (object):

=== modified file 'start-loggerhead.py'
--- start-loggerhead.py	2008-03-08 22:55:27 +0000
+++ start-loggerhead.py	2007-09-04 17:06:03 +0000
@@ -12,7 +12,7 @@
 import cherrypy
 cherrypy.lowercase_api = True
 
-from loggerhead import daemon, release
+from loggerhead import daemon, release, util
 
 
 def make_handler(config, filename):
@@ -86,7 +86,7 @@
     
     turbogears.update_config(configfile="dev.cfg", modulename="loggerhead.config")
     
-    potential_overrides = [ ('server.socket_port', int), ('server.webpath', str), ('server.thread_pool', int), ('server.socket_host' ,str) ]
+    potential_overrides = [ ('server.socket_port', int), ('server.webpath', str), ('server.thread_pool', int) ]
     for key, keytype in potential_overrides:
         value = config.get(key, None)
         if value is not None:
@@ -114,6 +114,7 @@
     index_freq = config.get('cache_rebuild_frequency', 6 * 3600)
     turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=Root._check_rebuild)
 
+    util.set_date_format(config.get('date_format', 'fancy'))
     try:
         turbogears.start_server(Root)
     finally:

